/*
 *    trakkcor - j2me gps tracking
 *    Copyright (C) 2006  Heiko Maa (trakkcor@javablog.ch)
 * 
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 * 
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package ch.javablog.mobile.trakkcor;

import ch.javablog.mobile.trakkcor.controller.Controller;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import net.sf.microlog.Logger;
import net.sf.microlog.util.GlobalProperties;

/**
 * @author Heiko Maa
 */
public class TrakkcorMIDlet extends MIDlet {
    private Display display;
    private Controller controller;
    private static Logger log = Logger.getLogger();
    
    public void startApp() { // get controller
        // init logging
        GlobalProperties.init(this);
        GlobalProperties props = GlobalProperties.getInstance();

        log.configure(props.getProperties());
        // get display
        if (display == null) {
             display = Display.getDisplay(this);
        }   

        try {
            if (controller == null) {
                controller = Controller.getInstance(this);
            }
           controller.forward("start");
        } catch (PlugInException e) {
            this.showDisplayable(new FatalErrorUI(e.toString()));
        }
    }
    
    public void pauseApp() {
    }
    
    public void showDisplayable(Displayable d) {
        display.setCurrent(d);

    }
    
    public void destroyApp(boolean unconditional) {
        notifyDestroyed();
    }
    
    private class FatalErrorUI extends Alert implements CommandListener {
        public FatalErrorUI(final String msg) {
            super("Fatal Error",msg,null,null);
            this.setCommandListener(this);
        }

        public void commandAction(final Command command, final Displayable displayable) {
            TrakkcorMIDlet.this.destroyApp(false);
        }
        
    }
}
