/*
 *    trakkcor - j2me gps tracking
 *    Copyright (C) 2006  Heiko Maa (trakkcor@javablog.ch)
 * 
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 * 
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package ch.javablog.mobile.trakkcor.controller;

import ch.javablog.mobile.trakkcor.model.BluetoothDeviceList;
import ch.javablog.mobile.trakkcor.service.GPSReceiver;
import ch.javablog.mobile.trakkcor.model.TrackList;
import ch.javablog.mobile.trakkcor.rms.Configuration;
import javax.microedition.lcdui.Displayable;

/**
 *
 * @author Heiko Maa
 */
public interface ExecutionContext {
    /**
     * Gets the GPSReceiver object which is responsible for 
     * communicate with an external gps receiver.
     */ 
    public GPSReceiver getGPSReceiver();
    
    /**
     * Gets a Displayable object under the given name. Each UI
     * of {@link ch.javablog.mobile.trakkcor.ui} package is mapped
     * to an unique name.
     */ 
    public Displayable getDisplayable(String uiName);
    
    /**
     * Gets the central configuration object.
     */ 
    public Configuration getConfiguration();
    
    /**
     * Gets the TrackList which is used to load and save tracks.
     */ 
    public TrackList getTrackList();
    
    /**
     * Gets the BluetoothDeviceList which stores the retrieved bluetooth
     * devices.
     */
    public BluetoothDeviceList getBluetoothDeviceList();
     
}
