 /*   
 *    trakkcor - j2me gps tracking
 *    Copyright (C) 2006  Heiko Maa (trakkcor@javablog.ch)
 * 
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 * 
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package ch.javablog.mobile.trakkcor.controller.action;

import ch.javablog.mobile.trakkcor.controller.ExecutionContext;
import ch.javablog.mobile.trakkcor.model.BluetoothDeviceList;
import javax.bluetooth.BluetoothStateException;
import javax.bluetooth.DeviceClass;
import javax.bluetooth.DiscoveryAgent;
import javax.bluetooth.DiscoveryListener;
import javax.bluetooth.LocalDevice;
import javax.bluetooth.RemoteDevice;
import javax.bluetooth.ServiceRecord;
import net.sf.microlog.Logger;

/**
 *
 * @author Heiko Maa
 */
public class DeviceDiscoverySearchAction implements Action, DiscoveryListener {
    private ExecutionContext context;
    private DiscoveryAgent agent;
    private final static Logger LOG = Logger.getLogger();
    
    public synchronized void execute(final ExecutionContext context) {
        Logger log = Logger.getLogger();
        log.debug("execute: DeviceDiscoverySearchAction...");
        this.context = context;
        // startInquiry
        try {
            LocalDevice local = LocalDevice.getLocalDevice();
            agent = local.getDiscoveryAgent();
            
            agent.startInquiry(DiscoveryAgent.GIAC, this);
            context.getBluetoothDeviceList().setInquery(true); 
        } catch (BluetoothStateException e) {
             log.error(e.toString(),e);
            // @todo handle exception properly}
        }
        log.debug("DeviceDiscoverySearchAction finished...");
    }
    
    public void cancel(final ExecutionContext context) {
        
    }

    public void deviceDiscovered(final RemoteDevice remoteDevice, final DeviceClass deviceClass) {
        LOG.debug("remoteDevice discovered: " + remoteDevice.getBluetoothAddress());
        // Service Class 0x10000 = Positioning
        //if ((deviceClass.getServiceClasses() & 0x10000) != 0) {
            BluetoothDeviceList bdl = context.getBluetoothDeviceList();
            bdl.addDevice(remoteDevice);
        //}
    }
    public void servicesDiscovered(int i, ServiceRecord[] serviceRecord) {
       // not used in this class
    }

    public void serviceSearchCompleted(int i, int i0) {
        // not used in this class. 
    }
   
    public void inquiryCompleted(int type) {
       context.getBluetoothDeviceList().setInquery(false);
    }
}
