/*
 *    trakkcor - j2me gps tracking
 *    Copyright (C) 2006  Heiko Maa (trakkcor@javablog.ch)
 * 
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 * 
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package ch.javablog.mobile.trakkcor.controller.action;

import ch.javablog.mobile.trakkcor.controller.ExecutionContext;
import ch.javablog.mobile.trakkcor.controller.listener.GPSListener;
import ch.javablog.mobile.trakkcor.service.GPSReceiver;
import net.sf.microlog.Logger;

/**
 *
 * @author Heiko Maa
 */
public class GPSReceiveStopAction implements Action {
    public final GPSListener listener;
    private final static Logger LOG = Logger.getLogger();
    
    public GPSReceiveStopAction(final GPSListener listener) {
        this.listener = listener;
    }
    
    public void execute(ExecutionContext context) {
        LOG.debug("GPSReceiveStopAction started...");
        GPSReceiver receiver = context.getGPSReceiver();
       
        receiver.removeListener(listener);
        receiver.stop();
        LOG.debug("GPSReceiveStopAction finished...");
    }

    public void cancel(ExecutionContext context) {
    }
}
