/*
 *    trakkcor - j2me gps tracking
 *    Copyright (C) 2006  Heiko Maa (trakkcor@javablog.ch)
 * 
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 * 
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package ch.javablog.mobile.trakkcor.controller.action;

import ch.javablog.mobile.trakkcor.controller.ExecutionContext;
import ch.javablog.mobile.trakkcor.model.Track;
import ch.javablog.mobile.trakkcor.model.TrackList;
import ch.javablog.mobile.trakkcor.model.TrackListException;
import ch.javablog.mobile.trakkcor.ui.TrackUI;
import net.sf.microlog.Logger;

/**
 *
 * @author Heiko Maa
 */
public class LoadTrackAction implements Action {

    private final static Logger LOG = Logger.getLogger();
    private final int id;
    /** Creates a new instance of LoadTrackAction */
    public LoadTrackAction(int id) {
        this.id = id;
    }

    public void execute(final ExecutionContext context) {
        LOG.debug("LoadTrackAction started...");
        try {
            final TrackList list = context.getTrackList();
            final Track track  =  list.getTrackById(id);
            final TrackUI trackUI = (TrackUI) context.getDisplayable("track");
            trackUI.setTrack(track);
        } catch (TrackListException te) {
            LOG.error(te.toString());
        }
        LOG.debug("LoadTrackAction finished...");
    }

    public void cancel(ExecutionContext context) {
    }
    
}
