/*
 *    trakkcor - j2me gps tracking
 *    Copyright (C) 2006  Heiko Maa (trakkcor@javablog.ch)
 * 
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 * 
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package ch.javablog.mobile.trakkcor.controller.action;

import ch.javablog.mobile.trakkcor.controller.ExecutionContext;
import ch.javablog.mobile.trakkcor.model.Track;
import ch.javablog.mobile.trakkcor.model.TrackList;
import ch.javablog.mobile.trakkcor.model.TrackListException;
import ch.javablog.mobile.trakkcor.ui.TrackUI;
import net.sf.microlog.Logger;

/**
 * Creates a new track, starts gps receving and forwards to TrackUI.
 * @author Heiko Maa
 */
public class NewTrackAction implements Action {
    private final static Logger LOG = Logger.getLogger();
    
    public void execute(ExecutionContext context) {
        LOG.debug("NewTrackAction started...");
        final TrackList list = context.getTrackList();
        Track newTrack = null;
        try {
            newTrack = list.createTrack();
        } catch (TrackListException e) {
            // FIXME: handle exception
        }
        TrackUI trackUI = (TrackUI) context.getDisplayable("track");
        trackUI.setTrack(newTrack);
        LOG.debug("NewTrackAction finished...");
    }
    
    public void cancel(ExecutionContext context) {
        
    }
    
}
