package ch.javablog.mobile.trakkcor.controller.action;



import net.sf.microlog.Logger;
import ch.javablog.mobile.trakkcor.controller.ExecutionContext;
import ch.javablog.mobile.trakkcor.model.NMEAMessage;
import ch.javablog.mobile.trakkcor.rms.Configuration;
import ch.javablog.mobile.trakkcor.service.TrakkSender;

/**
 * @author Thomas Eichmann, namics ag
 *
 **/
public class SendLiveTrackAction implements Action {
    private final static Logger LOG = Logger.getLogger();
    
    /** Current point of the live track. */
    private final NMEAMessage point;
    
    public SendLiveTrackAction(final NMEAMessage point) {
        this.point = point;
    }
    
    public void execute(final ExecutionContext context) throws ActionException {
        LOG.debug("SendLiveTrackAction stared...");
        final Configuration conf = context.getConfiguration();
        final TrakkSender sender = conf.getTrakkSender();
        sender.sendSinglePoint(point, conf.getUrl(), conf.getDeviceId());
        LOG.debug("SendLiveTrackAction finished...");
    }
    
    public void cancel(final ExecutionContext context) throws ActionException {
    }
    
}
