/*
 * GPGGAMessageTest.java
 * JMUnit based test
 *
 * Created on 28.06.2008, 23:35:14
 */

package ch.javablog.mobile.trakkcor.model;

import java.util.Date;
import jmunit.framework.cldc10.*;

/**
 * @author hmaass
 */
public class GPGGAMessageTest extends TestCase {
    private GPGGAMessage instance;
    public GPGGAMessageTest() {
        //The first parameter of inherited constructor is the number of test cases
        super(9,"GPGGAMessageTest");
        instance = new GPGGAMessage();
        instance.parseMessage("$GPGGA,130305.0,6643.2,N,00833.912,E,1,08,0.94,00499,M,047,M,,*\r\n");
    }            

    public void test(int testNumber) throws Throwable {
        switch (testNumber) {
            case 0:
                testGetMessage();
                break;
            case 1:
                testGetLongitude();
                break;
            case 2:
                testGetHdop();
                break;
            case 3:
                testGetNumberOfSatellites();
                break;
            case 4:
                testGetQualityIndicator();
                break;
            case 5:
                testIsValid();
                break;
            case 6:
                testGetGeoidealSeparation();
                break;
            case 7:
                testGetAltitude();
                break;
            case 8:
                testGetLatitude();
                break;
            default:
                break;
        }
    }

    /**
     * Test of testGetMessage method, of class GPGGAMessage.
     */
    public void testGetMessage() throws AssertionFailedException {
        System.out.println("getMessage");
        String expResult_1 = "$GPGGA,130305.0,6643.2,N,00833.912,E,1,08,0.94,00499,M,047,M,,*\r\n";
        String result_1 = instance.getMessage();
        assertEquals(expResult_1, result_1);
        //4533.35 is 45 degrees and 33.35 minutes
    }

    /**
     * Test of testGetLongitude method, of class GPGGAMessage.
     */
    public void testGetLongitude() throws AssertionFailedException {
        System.out.println("getLongitude");
        double expResult_1 = 8.5652;
        double result_1 = instance.getLongitude();
        System.out.println(result_1);
        assertTrue(expResult_1 == result_1);
    }

    /**
     * Test of testGetHdop method, of class GPGGAMessage.
     */
    public void testGetHdop() throws AssertionFailedException {
        System.out.println("getHdop");
        double expResult_1 = 0.94;
        double result_1 = instance.getHdop();
        assertTrue(expResult_1 == result_1);
    }

    /**
     * Test of testGetNumberOfSatellites method, of class GPGGAMessage.
     */
    public void testGetNumberOfSatellites() throws AssertionFailedException {
        System.out.println("getNumberOfSatellites");
        int expResult_1 = 8;
        int result_1 = instance.getNumberOfSatellites();
        assertEquals(expResult_1, result_1);
    }

    /**
     * Test of testGetQualityIndicator method, of class GPGGAMessage.
     */
    public void testGetQualityIndicator() throws AssertionFailedException {
        System.out.println("getQualityIndicator");
        int expResult_1 = 1;
        int result_1 = instance.getQualityIndicator();
        assertEquals(expResult_1, result_1);
    }

    /**
     * Test of testGetUtcDate method, of class GPGGAMessage.
     */
    public void testGetUtcDate() throws AssertionFailedException {
        System.out.println("getUtcDate");
        Date expResult_1 = null;
        Date result_1 = instance.getUtcDate();
        assertEquals(expResult_1, result_1);
    }

    /**
     * Test of testIsValid method, of class GPGGAMessage.
     */
    public void testIsValid() throws AssertionFailedException {
        System.out.println("isValid");
        boolean expResult_1 = true;
        boolean result_1 = instance.isValid();
        assertEquals(expResult_1, result_1);
    }


    /**
     * Test of testGetGeoidealSeparation method, of class GPGGAMessage.
     */
    public void testGetGeoidealSeparation() throws AssertionFailedException {
        System.out.println("getGeoidealSeparation");
        double expResult_1 = 47.0;
        double result_1 = instance.getGeoidealSeparation();
        assertTrue(expResult_1 == result_1);
    }

    /**
     * Test of testGetAltitude method, of class GPGGAMessage.
     */
    public void testGetAltitude() throws AssertionFailedException {
        System.out.println("getAltitude");
        double expResult_1 = 499.0;
        double result_1 = instance.getAltitude();
        assertTrue(expResult_1 == result_1);
    }

    /**
     * Test of testGetLatitude method, of class GPGGAMessage.
     */
    public void testGetLatitude() throws AssertionFailedException {
        System.out.println("getLatitude");
        double expResult_1 = 66.72;
        double result_1 = instance.getLatitude();
        assertTrue(expResult_1 == result_1);
    }
}
