/*
 * GPRMCMessageTest.java
 * JMUnit based test
 *
 * Created on 29.06.2008, 11:40:35
 */

package ch.javablog.mobile.trakkcor.model;


import java.util.Date;
import jmunit.framework.cldc10.*;

/**
 * @author hmaass
 */
public class GPRMCMessageTest extends TestCase {
    private GPRMCMessage instance;
    private static String gprmcMessage = "$GPRMC,191410.00,A,4736.6,S,00739.9,W,3.2,0.0,181102,0.4,E,A*19"; 
       
    public GPRMCMessageTest() {
         //The first parameter of inherited constructor is the number of test cases
        super(7,"GPRMCMessageTest");
        this.instance = new GPRMCMessage();
        this.instance.parseMessage(gprmcMessage);
    }            

    public void test(int testNumber) throws Throwable {
        switch (testNumber) {
            case 0:
                testGetLongitude();
                break;
            case 1:
                testGetMessage();
                break;
            case 2:
                testGetSpeedOverGround();
                break;
            case 3:
                testIsValid();
                break;
            case 4:
                testGetLatitude();
                break;
            case 5:
                testGetStatus();
                break;
            default:
                break;
        }
    }

    /**
     * Test of testGetLongitude method, of class GPRMCMessage.
     */
    public void testGetLongitude() throws AssertionFailedException {
        System.out.println("getLongitude");
        double expResult_1 = -7.665;
        double result_1 = instance.getLongitude();
        assertTrue(expResult_1 == result_1);
    }

    /**
     * Test of testGetMessage method, of class GPRMCMessage.
     */
    public void testGetMessage() throws AssertionFailedException {
        System.out.println("getMessage");
        String expResult_1 = gprmcMessage;
        String result_1 = instance.getMessage();
        assertEquals(expResult_1, result_1);
    }

    /**
     * Test of testGetSpeedOverGround method, of class GPRMCMessage.
     */
    public void testGetSpeedOverGround() throws AssertionFailedException {
        System.out.println("getSpeedOverGround");
        double expResult_1 = 3.2;
        double result_1 = instance.getSpeedOverGround();
        System.out.println(result_1);
        assertTrue(expResult_1 == result_1);
    }

    /**
     * Test of testIsValid method, of class GPRMCMessage.
     */
    public void testIsValid() throws AssertionFailedException {
        System.out.println("isValid");
        boolean expResult_1 = true;
        boolean result_1 = instance.isValid();
        assertEquals(expResult_1, result_1);
    }

    /**
     * Test of testGetLatitude method, of class GPRMCMessage.
     */
    public void testGetLatitude() throws AssertionFailedException {
        System.out.println("getLatitude");
        double expResult_1 = -47.61;
        double result_1 = instance.getLatitude();
        assertTrue(expResult_1 == result_1);
    }

    /**
     * Test of testGetStatus method, of class GPRMCMessage.
     */
    public void testGetStatus() throws AssertionFailedException {
        System.out.println("getStatus");
        String expResult_1 = "A";
        String result_1 = instance.getStatus();
        assertEquals(expResult_1, result_1);
    }
}
