/*
 *    trakkcor - j2me gps tracking
 *    Copyright (C) 2006  Heiko Maa (trakkcor@javablog.ch)
 * 
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 * 
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */
package ch.javablog.mobile.trakkcor.model;

import ch.javablog.mobile.trakkcor.PlugIn;
import ch.javablog.mobile.trakkcor.controller.listener.TrackListListener;
import java.util.Enumeration;

/**
 *
 * @author Heiko Maa
 */
public interface TrackList extends PlugIn {
    
    public Track getTrackById(int id) throws TrackListException;
    public void addListener(TrackListListener listener);
    public Track createTrack() throws TrackListException;
    public Enumeration allIds() throws TrackListException;
    public void persistTrack(Track t) throws TrackListException;
    public void removeTrack(int id) throws TrackListException;
    public void removeAllTracks() throws TrackListException;
    public int size() throws TrackListException;
}
