/*
 *    trakkcor - j2me gps tracking
 *    Copyright (C) 2006  Heiko Maa (trakkcor@javablog.ch)
 * 
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 * 
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */
package ch.javablog.mobile.trakkcor.service;

import ch.javablog.mobile.trakkcor.controller.listener.GPSListener;
import ch.javablog.mobile.trakkcor.model.NMEAMessageType;

/**
 *
 *  @author Heiko Maa
 */
public interface GPSReceiver {
    public void setBluetoothAddress(String bluetoothAddress); 
    public void addListener(GPSListener listener);
    public void removeListener(GPSListener listener);
    public void notifyListeners();
    public void setNMEAMessageType(NMEAMessageType nmeaMessageType);
    /**
     * Starts receiving process in background. The listeners will be notified
     * if a message was successfully received. 
     * @param period the period in milliseconds the gps receiver is accessed. 
     * 
     */
    public void start(long period);
    
    /**
     * Stops the receiving process.
     */
    public void stop();
}
