/*
 *    trakkcor - j2me gps tracking
 *    Copyright (C) 2006  Heiko Maa (trakkcor@javablog.ch)
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package ch.javablog.mobile.trakkcor.service.impl;

import java.io.IOException;
import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;
import net.sf.microlog.Logger;

/**
 * 
 * @author Heiko Maa
 */
public class HttpGetTrakkSender extends AbstractTrakkSender{
    private final static Logger LOG = Logger.getLogger();
    public String toString() {
        return "GET";
    }
    protected void submit(String data, String URL ) {
        HttpConnection connection = null;
        try {
            LOG.info("HttpGetTrakkSender:URL: " + URL + "?" + data);
            connection = (HttpConnection) Connector.open(URL + "?" +data);
           
            LOG.info("end of data input stream");
            int responseCode = connection.getResponseCode();
            if(responseCode == HttpConnection.HTTP_OK) {
                LOG.info("HttpGetTrakkSender:server answered: " + connection.getResponseMessage());
            } else if (responseCode == HttpConnection.HTTP_UNAUTHORIZED) {
                LOG.error("HttpGetTrakkSender:Server requires authentication. At the moment this is not implemented");
            } else {
                LOG.warn("HttpGetTrakkSender:server answered: " + connection.getResponseMessage());
            }
        } catch (IOException io) {
            LOG.error("HttpPostTrakkSender:io exception: " + io);
        } finally {
            if (connection != null) {
                try{
                    connection.close();
                } catch (IOException ignored) {
                }
            }
        }
    }
        
}
    
    
        

