/*
 *    trakkcor - j2me gps tracking
 *    Copyright (C) 2006  Heiko Maa (trakkcor@javablog.ch)
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package ch.javablog.mobile.trakkcor.service.impl;
//
import java.io.DataOutputStream;
import java.io.IOException;
import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;
import net.sf.microlog.Logger;

/**
 *
 * @author Heiko Maa
 */
public class HttpPostTrakkSender extends AbstractTrakkSender{
    
    private final static Logger LOG = Logger.getLogger();
    
    protected void submit(final String data, final String URL ) {
        HttpConnection   con        = null;
        DataOutputStream dos        = null;
        try {
            final byte[] requestBodyArray = data.getBytes();
            LOG.debug("opening WRITE connetion...");
            con = (HttpConnection) Connector.open(URL,Connector.WRITE);
            con.setRequestMethod(HttpConnection.POST);
            con.setRequestProperty("Content-Type","application/x-www-form-urlencoded");
            con.setRequestProperty("Content-Length", requestBodyArray.length + "");
            dos = con.openDataOutputStream();
            LOG.debug("writing requestBody...");

            for (int i = 0; i < requestBodyArray.length; i++) {
                dos.writeByte(requestBodyArray[i]);
            }

            dos.flush();
            dos.close();
        } catch (IOException e) {
            LOG.error(e.getMessage());
        } finally {
            if (con != null) {
                try {
                    con.close();
                } catch (IOException e) {
                    LOG.error(e.getMessage());
                }
            }
            if(dos != null) {
                try {
                    dos.close();
                } catch (IOException e) {
                    LOG.error(e.getMessage());
                }
            }
        }
    }        
    public String toString() {
        return "POST";
    }
}
