/*
 *    trakkcor - j2me gps tracking
 *    Copyright (C) 2008  Heiko Maa (trakkcor@javablog.ch)
 * 
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 * 
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package ch.javablog.mobile.trakkcor.ui;

import ch.javablog.mobile.trakkcor.Constants;
import ch.javablog.mobile.trakkcor.controller.Controller;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.StringItem;

/**
 *
 * @author Heiko Maa
 */
public class InfoUI extends Form implements CommandListener {
    private Controller controller;
    private final Command backCommand;
            
    /** Creates a new instance of LogUI */
    public InfoUI(Controller controller) {
        super("trakkcor");
        this.append(new StringItem("version",Constants.TRAKKCOR_VERSION));
        this.append(new StringItem("copyright","2008 Heiko Maa"));
        this.append(new StringItem("website","www.trakkcor.ch"));
        this.append(new StringItem("email","trakkcor@javablog.ch"));
        this.append(new StringItem("license", "This program is free software; you can redistribute it and/or modify " +
                "it under the terms of the GNU General Public License as published by " +
                "the Free Software Foundation; either version 2 of the License, or " +
                "(at your option) any later version." +
                "" +
                "This program is distributed in the hope that it will be useful, " +
                " but WITHOUT ANY WARRANTY; without even the implied warranty of " +
                "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the " +
                "GNU General Public License for more details. " +
                "" +
                "You should have received a copy of the GNU General Public License along " +
                "with this program; if not, write to the Free Software Foundation, Inc., " +
                "51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA."));
        this.controller = controller;
        this.backCommand = new Command("Back",Command.BACK,1);
        this.addCommand(backCommand);
        this.setCommandListener(this);
    }

    public void commandAction(Command command, Displayable displayable) {
        if (command == backCommand) {
            controller.forward("start");
        }
    }
    
}
