/*
 *    trakkcor - j2me gps tracking
 *    Copyright (C) 2006  Heiko Maa (trakkcor@javablog.ch)
 * 
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 * 
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */
package ch.javablog.mobile.trakkcor.ui;

import ch.javablog.mobile.trakkcor.controller.Controller;
import ch.javablog.mobile.trakkcor.controller.action.LoadTrackAction;
import ch.javablog.mobile.trakkcor.controller.listener.TrackListListener;
import java.util.Enumeration;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.List;

/**
 *
 * @author Heiko Maa
 */
public class LoadTrackUI extends List implements CommandListener, TrackListListener {
    private final Controller controller;
    private final Command    selectCommand = new Command("Select",Command.ITEM,1);
    private final Command    backCommand   = new Command("Back", Command.BACK,2); 
    
    public LoadTrackUI(Controller controller) {
        super("Available Tracks", List.IMPLICIT);
        this.controller = controller;
        this.setSelectCommand(selectCommand);
        this.addCommand(backCommand);
        this.setCommandListener(this);
    }

    public void commandAction(Command command, Displayable displayable) {
        if (command == backCommand) {
            controller.forward("startTrack");
        } else if (command == selectCommand) {
         
            int selectedIndex = this.getSelectedIndex();
            if (selectedIndex >= 0) {
                String trackIDAsString = this.getString(selectedIndex);
                int trackID = Integer.parseInt(trackIDAsString);
                LoadTrackAction lta = new LoadTrackAction(trackID);
                controller.executeAction(lta);
                controller.forward("track");
            }
        }
    }

    public void trackListModified(Enumeration ids) {
        this.deleteAll();
        while (ids.hasMoreElements()) {
            Integer id = (Integer) ids.nextElement();
            this.append("" + id.intValue(),null);
        }
    }


    
  
    
}
