/*
 *    trakkcor - j2me gps tracking
 *    Copyright (C) 2006  Heiko Maa (trakkcor@javablog.ch)
 * 
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 * 
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package ch.javablog.mobile.trakkcor.ui;

import ch.javablog.mobile.trakkcor.controller.Controller;
import ch.javablog.mobile.trakkcor.controller.action.NewTrackAction;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.List;

/**
 *
 * @author Heiko Maa
 */
public class StartTrackUI extends List implements CommandListener {
    private final Controller controller;
    private final Command    select = new Command("Select",Command.ITEM,0);
    private final Command    back   = new Command("Back", Command.BACK,1);
    /**
     * Creates a new instance of StartTrackUI
     */
    public StartTrackUI(Controller controller) {
        super("Track",List.IMPLICIT);
        this.controller = controller;
        this.append("New Track", null);
        this.append("Load Track",null);
        this.append("Remove Track",null);
        this.append("Back",null);
        this.setSelectCommand(select);
        this.setCommandListener(this);
        this.addCommand(back);
    }

    public void commandAction(Command command, Displayable displayable) {
        if (command == select ) {
            int selectedIndex = this.getSelectedIndex();
            switch (selectedIndex) {
                case 0:
                    // new track 
                    NewTrackAction nta = new NewTrackAction();
                    controller.executeAction(nta);
                    controller.forward("track");
                    break;
                case 1:
                    // load track
                    controller.forward("loadTrack");
                    break;
                case 2:
                    // remove track
                    controller.forward("removeTrack");
                    break;
                case 3:
                    controller.forward("start");                    
                    break;       
            }
        } else if (command == back) {
            controller.forward("start");
        }
    }
}
