/*
 *    trakkcor - j2me gps tracking
 *    Copyright (C) 2006  Heiko Maa (trakkcor@javablog.ch)
 * 
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 * 
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package ch.javablog.mobile.trakkcor.ui;

import ch.javablog.mobile.trakkcor.controller.Controller;
import ch.javablog.mobile.trakkcor.controller.action.Action;
import ch.javablog.mobile.trakkcor.controller.action.DeviceDiscoveryPrepareAction;
import ch.javablog.mobile.trakkcor.controller.action.GPSReceiveStartAction;
import ch.javablog.mobile.trakkcor.controller.listener.GPSListener;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.List;

/**
 *
 * @author Heiko Maa
 */
public class StartUI extends List implements CommandListener{
    private final Controller controller;
    private final Command    select = new Command("Select",Command.ITEM,1);
    private final Command    exit   = new Command("Exit", Command.EXIT,2);
    
    /** Creates a new instance of StartUI */
    public StartUI(Controller controller) {
        super("trakkcor",List.IMPLICIT);
        this.controller = controller;
        this.append("GPS Position", null);
        this.append("GPS Track", null);
        this.append("Live Tracker", null);
        this.append("Device Discovery",null);
        this.append("Options",null);
        this.append("Info",null);
        this.append("Exit", null);
        this.append("Log",null);
        this.setSelectCommand(select);
        this.setCommandListener(this);
    }
    
    public void commandAction(final Command command, Displayable d) {
        if (command == select) {
            int selectedIndex = this.getSelectedIndex();
             Action action = null;
            switch (selectedIndex) {
 
                case 0:
                    GPSListener listener = (GPSListener) controller.getDisplayable("gps");
                    action = new GPSReceiveStartAction(listener);
                    controller.executeAction(action);
                    controller.forward("gps");
                    break;
                case 1:
                    controller.forward("startTrack");
                    break;                    
                case 2:
                	controller.forward("liveTracker");
                	break;
                case 3:
                    // Execute Action: 
                    action = new DeviceDiscoveryPrepareAction();
                    controller.executeAction(action);
                    controller.forward("deviceDiscovery");
                    break;
                case 4:
                    controller.forward("options");
                    break;
                case 5:
                    controller.forward("info");
                    break;  
                case 6:
                    controller.exit();
                    break;
                case 7:
                    controller.forward("log");
                    break;
            }
        }
    }
}
