/*
 *    trakkcor - j2me gps tracking
 *    Copyright (C) 2006  Heiko Maa (trakkcor@javablog.ch)
 * 
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 * 
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package ch.javablog.mobile.trakkcor.util;

/**
 *
 * @author Heiko Maa
 */
public class StringTokenizer {
    private int lastPosition    = 0;
    private String str          = "";
    private String delimiter    = "";
    /** Creates a new instance of StringTokenizer */
    public StringTokenizer(String str, String delimiter) {
        this.str = str;
        this.delimiter = delimiter;
    }
    
    public String nextToken() {
        String token = null;
        if (lastPosition == str.length()) {
            return null;
        }        
        int endIndex = str.indexOf(delimiter,lastPosition);
        if (endIndex != -1) {
            token = str.substring(lastPosition,endIndex);
            lastPosition = endIndex+1;
        } else {
            // last token
            token = str.substring(lastPosition,str.length());
            lastPosition = str.length();
        }
        return token;
    }
}
